$:.unshift File.expand_path("../../lib", __FILE__)
$:.unshift File.expand_path("../../test", __FILE__)

require "test/unit"
require 'thrift'
require "thrift_client"
require 'yaml'
require 'em-synchrony'
require 'subscribe'

class ClientTest < Test::Unit::TestCase
  include Test::Unit::Assertions
  def setup
    super
    root = File.expand_path("../..", __FILE__)
    @config = YAML.load_file(File.join(root, 'test/thrift_config.yaml'))
    puts "setup"
  end

  def test_client
    EM.synchrony do
      client = ThriftClient.new(@config['client_test'])
      for i in 1 .. 1000
        puts client.subscribe(1,i)
      end
      # puts client.isSubscribe(1,[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20])
      EM.stop
    end
  end

  def test_GetSubscriptions

    EM.synchrony do
      client = ThriftClient.new(@config['client_test'])
      for i in 1 .. 1000
        subscriptions = client.getSubscriptions(1)
      end
      # puts client.isSubscribe(1,[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20])
      EM.stop
    end
  end

  def teardown
    super
    EM.synchrony do
      client = ThriftClient.new(@config['client_test'])
      subscriptions = client.getSubscriptions(1)
      subscriptions.each { |subscription|
        puts subscription.inspect
        client.unsubscribe(subscription.id,subscription.uid,subscription.albumId)
      }
      EM.stop
    end
    puts "teardown"
  end
end
